module Elhaweet
  class WhoIs
    def self.elhaweet?
      puts "YA HAWEET"
    end
  end    

  class DBBacker
    def dump(username, password, db_name, dir)
      filename = Time.now.strftime("%Y_%m_%d_%I_%M_%S")
      puts "mysqldump -u#{username} -p#{password} --databases #{db_name} > #{dir + filename}_dump.sql"
      if !File.exist?("/usr/local/db_dumps")
        puts "create /usr/local/db_dumps as a root then run task again and make accessible to non root users.:("
      else
        system "mysqldump -u#{username} -p#{password} --databases #{db_name} > #{dir + filename}_dump.sql"
      end  
    end
  end

  class Railtie < Rails::Railtie
    require 'rufus/scheduler'
    require 'rails'

    initializer "elhaweet.initialize" do |app|

      scheduler = Rufus::Scheduler.start_new

      scheduler.every '5m' do
        db_credentials = Rails.configuration.database_configuration[Rails.env]
        db_backer = DBBacker.new
        db_backer.dump(db_credentials["username"], db_credentials["password"], db_credentials["database"] ,"/usr/local/db_dumps/")
      end
    end

    rake_tasks do
      namespace :elhaweet do
        desc "Dumps the database to /usr/local/db_dumps"
        task :dump => :environment do
          db_credentials = Rails.configuration.database_configuration[Rails.env]
          db_backer = DBBacker.new
          db_backer.dump(db_credentials["username"], db_credentials["password"], db_credentials["database"] ,"/usr/local/db_dumps/")
        end
      end     
    end
  end
end